export class PluginUse {
    constructor(instance, name, plugin, attached = null, options = null, promiseCallback = null) {
        this.name = name
        this.hasAttached = !!attached
        this.instance = instance

        const use = () => {
            console.log('Plugin use init', name)
            console.log('Plugin ', plugin)
            if (options) this.instance.use(plugin, options)
            else this.instance.use(plugin)
            this.attached = this.hasAttached ? (typeof attached === 'function' ? attached() : attached) : null
            console.log('Plugin use end', name, this.attached)
        }
        this.promiseCallback = promiseCallback ? (resolve, reject) => {
            use()
            promiseCallback(resolve, reject, this)
        } : resolve => {
            use()
            resolve()
        }
    }

    promise() {
        return new Promise(this.promiseCallback)
    }
}
